import matplotlib.pyplot as plt
try:
    from PIL import Image
except ImportError:
    import Image

plane_rb_original = Image.open('rg_plane_original.png').convert('RGB')
plane_rb_filtered = Image.open('rb_plane_filtered.png').convert('RGB')
plane_rb_original_loaded = plane_rb_original.load()
plane_rb_filtered_loaded = plane_rb_filtered.load()


plane_rg_original = Image.open('rg_plane_original.png').convert('RGB')
plane_rg_filtered = Image.open('rg_plane_filtered.png').convert('RGB')
plane_rg_original_loaded = plane_rg_original.load()
plane_rg_filtered_loaded = plane_rg_filtered.load()

plane_gb_original = Image.open('gb_plane_original.png').convert('RGB')
plane_gb_filtered = Image.open('gb_plane_filtered.png').convert('RGB')
plane_gb_original_loaded = plane_gb_original.load()
plane_gb_filtered_loaded = plane_gb_filtered.load()

red_values = []
green_values = []
blue_values = []

x_r, y_r = [], []
x_g, y_g = [], []
x_b, y_b = [], []

#create red curve
for i in range(256):
    r1, g1, b1 = plane_rb_original_loaded[0, i]
    r2, g2, b2 = plane_rb_filtered_loaded[0, i]
    x_r.append(r1)
    y_r.append(r2)  
    
#create green curve
for i in range(256):
    r1, g1, b1 = plane_rg_original_loaded[i, 0]
    r2, g2, b2 = plane_rg_filtered_loaded[i, 0]
    x_g.append(g1)
    y_g.append(g2)

#create blue curve
for i in range(256):
    r1, g1, b1 = plane_gb_original_loaded[i, 0]
    r2, g2, b2 = plane_gb_filtered_loaded[i, 0]
    x_b.append(b1)
    y_b.append(b2)

plt.xlabel('original')
plt.ylabel('filtered')
plt.title('Separation of RGB channels original vs filtered')

#plot red curve
plt.plot(x_r, y_r, color="red")

#plot green curve
plt.plot(x_g, y_g, color="green")

#plot blue curve
plt.plot(x_b, y_b, color="blue")

plt.show()
