try:
    from PIL import Image
except ImportError:
    import Image

import os, sys

def count_error(pixel1, pixel2):
    # used to count difference between two given pixels
    # returns average of errors for each color channel
    (r1, g1, b1) = pixel1
    (r2, g2, b2) = pixel2
    error_red = ((abs(r1 - r2) / 255) * 100)
    error_green = ((abs(g1 - g2) / 255) * 100)
    error_blue = ((abs(b1 - b2) / 255) * 100)
    return error_red, error_green, error_blue


def count_error_between_two_images(img1_path, img2_path):
    img1 = Image.open(img1_path)
    img2 = Image.open(img2_path)

    img1_loaded = img1.load()
    img2_loaded = img2.load()

    assert (img1.size == img2.size)

    r_count, g_count, b_count = 0, 0, 0
    r_max, g_max, b_max = 0, 0, 0
    count = 0
    for i in range(img1.size[0]):
        for j in range(img1.size[1]):
            (r_error, g_error, b_error) = count_error(img1_loaded[i, j], img2_loaded[i, j])
            r_max = max(r_error, r_max)
            g_max = max(g_error, g_max)
            b_max = max(b_error, b_max)

            r_count = r_count + r_error
            g_count = g_count + g_error
            b_count = b_count + b_error
            count = count + 1

    print("Red: % 1.4f, %1.4f" % (r_count / count, r_max))
    print("Green: % 1.4f, %1.4f" % (g_count / count, g_max))
    print("Blue: % 1.4f, %1.4f" % (b_count / count, b_max))
