try:
    from PIL import Image
except ImportError:
    import Image

import os, sys

def generate_color_error(error):
    # A simple function that transforms counted error into color pixel representation
    red = int((error * 255) / 3)

    if red > 255:
        red = 255

    return red, 0, 255 - red

def create_error_images_for_rgb(img1_path, img2_path, error_image_name):
    img1 = Image.open(img1_path)
    img2 = Image.open(img2_path)
    error_image_red = Image.new('RGB', (1080, 1080), color='white')
    error_image_green = Image.new('RGB', (1080, 1080), color='white')
    error_image_blue = Image.new('RGB', (1080, 1080), color='white')
    error_image_total = Image.new('RGB', (1080, 1080), color='white')

    img1_loaded = img1.load()
    img2_loaded = img2.load()
    error_image_red_loaded = error_image_red.load()
    error_image_green_loaded = error_image_green.load()
    error_image_blue_loaded = error_image_blue.load()
    error_image_total_loaded = error_image_total.load()

    assert (img1.size == img2.size)

    for i in range(img1.size[0]):
        for j in range(img1.size[1]):
            (r_error, g_error, b_error) = count_error(img1_loaded[i, j], img2_loaded[i, j])
            error_image_red_loaded[i, j] = generate_color_error(r_error)
            error_image_green_loaded[i, j] = generate_color_error(g_error)
            error_image_blue_loaded[i, j] = generate_color_error(b_error)
            error_image_total_loaded[i, j] = generate_color_error((r_error + b_error + g_error)/3)

    error_image_red.save(error_image_name)
    error_image_green.save(error_image_name)
    error_image_blue.save(error_image_name)
    error_image_total.save(error_image_name)
