try:
    from PIL import Image
except ImportError:
    import Image

import os, sys

def countDiference(original_image, filtered_image, inverse, color):
    x1, y1 = [], []
    values = []
    for j in range(0, 256, 16):
        x1, y1 = [], []
        for i in range(0, 256, 16):
            if (inverse == False):
                (r1, g1, b1) = original_image[j, i]
                (r2, g2, b2) = filtered_image[j, i]
            else:
                (r1, g1, b1) = original_image[i, j]
                (r2, g2, b2) = filtered_image[i, j]

            if (color == "red"):
                a1 = r1
                a2 = r2
            elif (color == "green"):
                a1 = g1
                a2 = g2
            else:
                a1 = b1
                a2 = b2
            x1.append(a1)
            y1.append(a2)
        touple = (x1, y1)

        values.append(touple)
    return values


def generateGraph(title, color_of_image, values):
    plt.xlabel('original')
    plt.ylabel('filtered')
    plt.title(title)

    for i in range(0, len(values)):
        x, y = values[i]
        plt.plot(x, y, color=color_of_image)
    plt.show()
    return


def generateOppositeGraphs(color1, color2, values1, values2):
    title = "Dependency of " + color1 + " channel on " + color2 + " channel and VV"
    plt.xlabel('original')
    plt.ylabel('filtered')
    plt.title(title)

    for i in range(0, len(values1)):
        x, y = values1[i]
        plt.plot(x, y, color=color1)

    for i in range(0, len(values2)):
        x, y = values2[i]
        plt.plot(x, y, color=color2)

    plt.show()
    return


def generate_double_graphs(color1, color2, color3, values1, values2):
    title = "Dependency of " + color1 + " channel on " + color2 + " channel and " + color3 + " channel."
    plt.xlabel('original')
    plt.ylabel('filtered')
    plt.title(title)

    for i in range(0, len(values1)):
        x, y = values1[i]
        plt.plot(x, y, color=color2)

    for i in range(0, len(values2)):
        x, y = values2[i]
        plt.plot(x, y, color=color3)

    plt.show()
    return
